%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                              PSG Type    PSG Object                     Location in Problem Statement                                                     Class
%matrix_data_benchmark               bench       matrix_data                    meanabs_pen(spline_sum(matrix_parameters_30_pieces, matrix_data))                 double
%                                                                               st_pen(spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots))
%                                                                               spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots)
%matrix_data_data                    data        matrix_data                    meanabs_pen(spline_sum(matrix_parameters_30_pieces, matrix_data))                 double
%                                                                               st_pen(spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots))
%                                                                               spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots)
%matrix_data_vars                    vars        matrix_data                    meanabs_pen(spline_sum(matrix_parameters_30_pieces, matrix_data))                 cell
%                                                                               st_pen(spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots))
%                                                                               spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots)
%matrix_parameters_30_pieces_data    data        matrix_parameters_30_pieces    meanabs_pen(spline_sum(matrix_parameters_30_pieces, matrix_data))                 double
%                                                                               st_pen(spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots))
%                                                                               spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots)
%matrix_parameters_30_pieces_vars    vars        matrix_parameters_30_pieces    meanabs_pen(spline_sum(matrix_parameters_30_pieces, matrix_data))                 cell
%                                                                               st_pen(spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots))
%                                                                               spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots)
%parameter_precision_data            data        parameter_precision            Solver: precision = parameter_precision                                           char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_data_benchmark,matrix_data_data,matrix_data_vars,matrix_parameters_30_pieces_data,matrix_parameters_30_pieces_vars,parameter_precision_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_data',matrix_data_data,matrix_data_vars,matrix_data_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_parameters_30_pieces',matrix_parameters_30_pieces_data,matrix_parameters_30_pieces_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  meanabs_pen(spline_sum(matrix_parameters_30_pieces, matrix_data))',...
'Solver: precision = parameter_precision',...
'',...
'calculate',...
'Point: point_problem_1',...
'  st_pen(spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots))',...
'  spline_sum(matrix_parameters_30_pieces, matrix_data,matrix_data_knots)',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_precision',parameter_precision_data);

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

